/// <reference types="pouchdb-find" />
/// <reference types="pouchdb-core" />
/// <reference types="pouchdb-mapreduce" />
/// <reference types="pouchdb-replication" />
import { AggregateRoot } from '.';
import { IRepository } from '.';
import { Observable, BehaviorSubject } from 'rxjs';
import 'pouchdb';
declare const aggregateCache: unique symbol;
declare const queryCache: unique symbol;
export declare abstract class PouchdbRepository<Obj extends AggregateRoot & {
    id: string;
    json: IObj;
}, IObj extends {
    id: string;
}> implements IRepository<Obj, PouchDB.Find.FindRequest<IObj>> {
    db: PouchDB.Database<IObj>;
    [aggregateCache]: Map<string, {
        rev: string;
        aggregate: Obj;
    }>;
    [queryCache]: Map<PouchDB.Find.FindRequest<IObj>, {
        subject: BehaviorSubject<Obj[]>;
        ob: Observable<Obj[]>;
        ids: string[];
    }>;
    constructor(db: PouchDB.Database<IObj>);
    abstract Type: new (data: IObj) => Obj;
    save(todo: Obj): Promise<void>;
    private _obsNext;
    clearCache(): void;
    remove(id: string): Promise<void>;
    get(_id: string): Observable<Obj>;
    _find(req: PouchDB.Find.FindRequest<IObj>, subject: BehaviorSubject<Obj[]>, ob: Observable<Obj[]>): Promise<void>;
    find(req: PouchDB.Find.FindRequest<IObj>): Observable<Obj[]>;
}
export {};
